2024-12-26 06:00:03

检查用户是否存在

我想创建一个脚本来检查用户是否存在。我使用的逻辑如下:

# getent passwd test > /dev/null 2&>1
# echo $?
0
# getent passwd test1 > /dev/null 2&>1
# echo $?
2

如果用户存在,我们就成功,否则用户不存在。我已经把上面的命令在bash脚本如下:

#!/bin/bash

getent passwd $1 > /dev/null 2&>1

if [ $? -eq 0 ]; then
    echo "yes the user exists"
else
    echo "No, the user does not exist"
fi

现在,我的脚本总是说用户存在,不管怎样:

# sh passwd.sh test
yes the user exists
# sh passwd.sh test1
yes the user exists
# sh passwd.sh test2
yes the user exists

为什么上面的条件总是评估为TRUE,并说用户存在?

我哪里说错了?

更新:

在阅读了所有的回复后,我在我的剧本中发现了问题。问题是我重定向get输出的方式。所以我删除了所有重定向的东西,并使get行看起来像这样:

getent passwd $user  > /dev/null

现在我的脚本运行正常。


当前回答

我建议使用id命令,因为它测试有效的用户存在wrt passwd文件条目,这并不一定意味着相同:

if [ `id -u $USER_TO_CHECK 2>/dev/null || echo -1` -ge 0 ]; then 
echo FOUND
fi

备注:0为root uid。

其他回答

根据您的shell实现(例如Busybox vs. grown),[操作符可能会启动一个进程,更改$?

Try

getent passwd $1 > /dev/null 2&>1
RES=$?

if [ $RES -eq 0 ]; then
    echo "yes the user exists"
else
    echo "No, the user does not exist"
fi

实际上我无法重现这个问题。问题中编写的脚本工作正常,除了$1为空的情况。

但是,脚本中有一个与stderr重定向相关的问题。虽然存在两种形式&>和>&,但在您的情况下,您希望使用>&。您已经重定向了stdout,这就是&>表单不起作用的原因。你可以用下面的方法验证:

getent /etc/passwd username >/dev/null 2&>1
ls

您将在当前目录中看到一个名为1的文件。你想使用2>&1代替,或者使用这个:

getent /etc/passwd username &>/dev/null

这也将stdout和stderr重定向到/dev/null.

将stderr重定向到/dev/null可能不是一个好主意。当事情出错时,你将不知道为什么。

到目前为止最简单的解决方案:

if id -u "$user" >/dev/null 2>&1; then
    echo 'user exists'
else
    echo 'user missing'
fi

>/dev/null 2>&1在Bash中可以缩写为&>/dev/null,如果你只想知道一个用户是否不存在:

if ! id -u "$user" >/dev/null 2>&1; then
    echo 'user missing'
fi

没有必要显式地检查退出代码。试一试

if getent passwd $1 > /dev/null 2>&1; then
    echo "yes the user exists"
else
    echo "No, the user does not exist"
fi

如果这不起作用,则说明您的geent有问题,或者您定义的用户比您想象的要多。

这就是我最终在Freeswitch bash启动脚本中所做的:

# Check if user exists
if ! id -u $FS_USER > /dev/null 2>&1; then
    echo "The user does not exist; execute below commands to crate and try again:"
    echo "  root@sh1:~# adduser --home /usr/local/freeswitch/ --shell /bin/false --no-create-home --ingroup daemon --disabled-password --disabled-login $FS_USER"
    echo "  ..."
    echo "  root@sh1:~# chown freeswitch:daemon /usr/local/freeswitch/ -R"
    exit 1
fi